/**
 * 
 */
package org.mortbay.cometd;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Map;

import javax.servlet.http.HttpServletResponse;

import org.mortbay.util.ajax.JSON;

/* ------------------------------------------------------------ */
/**
 * @author aabeling
 * @author gregw
 * 
 */
public class JSONPTransport extends AbstractTransport
{
    int _responses=0;
    PrintWriter _out;
    boolean _verbose;
    String jsonp;

    public JSONPTransport()
    {
        /* intentionally left blank */
    }

    public void send(Map reply) throws IOException
    {
        StringBuilder sResponse=new StringBuilder();

        if (reply!=null)
        {
            if (_responses==0)
            {
                HttpServletResponse response=getResponse();
                response.setContentType("text/plain; charset=utf-8");
                _out=response.getWriter();

                _out.write(this.jsonp+"(");
                _out.write('[');
                sResponse.append(this.jsonp+"([");
            }
            else
            {
                _out.write(",\r\n");
                sResponse.append(",\r\n");
            }

            String r=JSON.toString(reply);
            if (_verbose)
                System.err.println("<="+_responses+"="+r);
            _responses++;
            _out.write(r);
            sResponse.append(r);
        }
    }

    public void complete() throws IOException
    {
        HttpServletResponse response=getResponse();
        response.setStatus(200);

        if (_responses==0)
            response.setContentLength(0);
        else
        {
            if (_verbose)
                System.err.println("<=-=");
            _out.write("])\r\n");
            _out.flush();
        }

    }

    public boolean keepAlive() throws IOException
    {
        return false;
    }

    public void setVerbose(boolean verbose)
    {
        _verbose=verbose;
    }

    public String getJsonp()
    {
        return jsonp;
    }

    public void setJsonp(String jsonp)
    {
        this.jsonp=jsonp;
    }

    public String toString()
    {
        return "JSONPTransport[jsonp="+this.jsonp+"]";
    }
}